local PoleFlag, PoleFlagPrefix = ...

--------------------------------------------------------------------------
local POLE_FLAG_FLAPING_COMP = {
	TypeName = PoleFlagPrefix .. "_FLAPING_COMP",
	ParentType = "COMPONENT",
	Properties = {
	}
}

--------------------------------------------------------------------------
function POLE_FLAG_FLAPING_COMP:create()
    self:init()
end

-------------------------------------------------------------------------
function POLE_FLAG_FLAPING_COMP:segmentRotation(_child, _currentAngle, _angle)
    _currentAngle = _currentAngle + _angle
    if _currentAngle < -self._maxAngle then
        _currentAngle = -self._maxAngle
    elseif _currentAngle > self._maxAngle then
        _currentAngle = self._maxAngle
    end 
    _child:setRotationY(_currentAngle)
    return _currentAngle
end

-------------------------------------------------------------------------
function POLE_FLAG_FLAPING_COMP:flapping(_angle1, _angle2, _angle3)
--    PoleFlag:log("flaping : angle = " .. _angle)
    self:getOwner():forEachChildRecursive(
        function(child)
            if child.Name == "flameFlag1" then
                self.currentAngle1 = self:segmentRotation(child, self.currentAngle1, _angle1)
            elseif child.Name == "flameFlag2" then
                self.currentAngle2 = self:segmentRotation(child, self.currentAngle2, _angle2)
            elseif child.Name == "flame3" then
                self.currentAngle3 = self:segmentRotation(child, self.currentAngle3, _angle3)
            end
        end
    )     
end

--------------------------------------------------------------------------
function POLE_FLAG_FLAPING_COMP:init()
--    PoleFlag:log("POLE_FLAG_FLAPING_COMP:init")
    self._initTimer = 3
    self._timer = self._initTimer
    self._maxAngle = math.pi/6
    self._randomAngle = (math.random()*0.8 + 0.2)*self._maxAngle
    self._speed = 2*math.pi/self._timer
    self._phi = math.pi/4
    self.currentAngle1 = 0
    self.currentAngle2 = self._maxAngle*math.sin(self._phi)
    self.currentAngle3 = self._maxAngle*math.sin(2*self._phi)
--   PoleFlag:log("POLE_FLAG_FLAPING_COMP:end init")
end

--------------------------------------------------------------------------
function POLE_FLAG_FLAPING_COMP:update()
 --   PoleFlag:log("POLE_FLAG_FLAPING_COMP:update")
    local dt = self:getLevel():getDeltaTime()
    local _postTimer = self._timer - dt
    local _arc1 = math.sin(_postTimer*self._speed)-math.sin(self._timer*self._speed)
    local _arc2 = math.sin(_postTimer*self._speed+self._phi)-math.sin(self._timer*self._speed+self._phi)
    local _arc3 = math.sin(_postTimer*self._speed+2*self._phi)-math.sin(self._timer*self._speed+2*self._phi)
    self:flapping(_arc1*self._randomAngle, _arc2*self._randomAngle, _arc3*self._randomAngle)
    self._timer= _postTimer
    if self._timer < 0 then
        self._timer = self._initTimer
        self._randomAngle = (math.random()*0.8 + 0.2)*self._maxAngle
    end
--    PoleFlag:log("POLE_FLAG_FLAPING_COMP:end update")
end

--------------------------------------------------------------------------
PoleFlag:registerClass(POLE_FLAG_FLAPING_COMP)
